/* -LICENSE-START-
** Copyright (c) 2019 Blackmagic Design
**  
** Permission is hereby granted, free of charge, to any person or organization 
** obtaining a copy of the software and accompanying documentation (the 
** "Software") to use, reproduce, display, distribute, sub-license, execute, 
** and transmit the Software, and to prepare derivative works of the Software, 
** and to permit third-parties to whom the Software is furnished to do so, in 
** accordance with:
** 
** (1) if the Software is obtained from Blackmagic Design, the End User License 
** Agreement for the Software Development Kit (“EULA”) available at 
** https://www.blackmagicdesign.com/EULA/DeckLinkSDK; or
** 
** (2) if the Software is obtained from any third party, such licensing terms 
** as notified by that third party,
** 
** and all subject to the following:
** 
** (3) the copyright notices in the Software and this entire statement, 
** including the above license grant, this restriction and the following 
** disclaimer, must be included in all copies of the Software, in whole or in 
** part, and all derivative works of the Software, unless such copies or 
** derivative works are solely in the form of machine-executable object code 
** generated by a source language processor.
** 
** (4) THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
** OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
** FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT 
** SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE 
** FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE, 
** ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
** DEALINGS IN THE SOFTWARE.
** 
** A copy of the Software is available free of charge at 
** https://www.blackmagicdesign.com/desktopvideo_sdk under the EULA.
** 
** -LICENSE-END-
*/

#pragma once

#include <comdef.h>
#include <comutil.h>
#include <string>
#include <functional>
#include <stdint.h>
#include "DeckLinkAPI.h"
#include "com_ptr.h"

HRESULT GetDeckLinkIterator(IDeckLinkIterator **deckLinkIterator);


#define dlbool_t	BOOL
#define dlstring_t	BSTR

// DeckLink String conversion functions
const auto DeleteString = ::SysFreeString;

const auto DlToStdString = [](dlstring_t dl_str) -> std::string {
	int wlen = static_cast<int>(::SysStringLen(dl_str));
	int mblen = ::WideCharToMultiByte(CP_ACP, 0, static_cast<wchar_t*>(dl_str), wlen, nullptr, 0, nullptr, nullptr);
	
	std::string ret_str(static_cast<size_t>(mblen), '\0');
	mblen = ::WideCharToMultiByte(CP_ACP, 0, static_cast<wchar_t*>(dl_str), wlen, &ret_str[0], mblen, nullptr, nullptr);

	return ret_str;
};

const auto StdToDlString = [](std::string std_str) -> dlstring_t {
	int wlen = ::MultiByteToWideChar(CP_ACP, 0, std_str.data(), static_cast<int>(std_str.length()), nullptr, 0);

	dlstring_t ret_str = ::SysAllocStringLen(nullptr, static_cast<UINT>(wlen));
	::MultiByteToWideChar(CP_ACP, 0, std_str.data(), static_cast<int>(std_str.length()), ret_str, wlen);

	return ret_str;
};

const auto DlToCString = _com_util::ConvertBSTRToString;



